package cz.zweistein.df.soundsense.gui.control;

import java.awt.GridLayout;
import java.awt.Label;
import java.util.Collections;

import javax.swing.JLabel;
import javax.swing.JPanel;

import cz.zweistein.df.soundsense.config.Sound;
import cz.zweistein.df.soundsense.config.SoundFile;
import cz.zweistein.df.soundsense.output.sound.player.PlayerManager;

public class SoundFileInfoPanel extends JPanel {
	private static final long serialVersionUID = 3819628170252365080L;
	
	final JLabel soundInfoFilenameLabel;
	final JLabel soundInfoWeightLabel;
	final JLabel soundInfoVolumeLabel;
	final StartSoundPlaybackButton soundInfoPlayButton;

	public SoundFileInfoPanel(PlayerManager manager) {
		super();
		
        this.setLayout(new GridLayout(0,2));

        this.add(new Label("Filename:"));
        soundInfoFilenameLabel = new JLabel();
        this.add(soundInfoFilenameLabel);
        
        this.add(new Label("Weight:"));
        soundInfoWeightLabel = new JLabel();
        this.add(soundInfoWeightLabel);
        
        this.add(new Label("Volume adjustment:"));
        soundInfoVolumeLabel = new JLabel();
        this.add(soundInfoVolumeLabel);
        
        this.add(new Label("Playback:"));
        soundInfoPlayButton = new StartSoundPlaybackButton(manager);
        this.add(soundInfoPlayButton);
	}

	public void updateSoundFile(SoundFile soundFile) {
		soundInfoFilenameLabel.setText(soundFile.getFileName());
		soundInfoWeightLabel.setText(Integer.toString(soundFile.getWeight()));
		soundInfoVolumeLabel.setText(Float.toString(soundFile.getVolumeAdjustment()));
		
		Sound dummySound = new Sound(null, Collections.singletonList(soundFile), null, null, "manual playback", Long.MAX_VALUE, false, false, 0L, "");
		
		soundInfoPlayButton.setSound(dummySound);
	}

}
